
from Tkinter import *
import ctypes

SET_DUTY = 17
DOT = 18
LINE = 19
CHECKERBOARD = 20
HALF_HALF = 21

usb = ctypes.cdll.LoadLibrary('usb.dll')
usb.initialize()

buffer = ctypes.c_buffer(8)

def dot_callback():
    usb.control_transfer(dev, 0x40, DOT, 0, 0, 0, buffer)

def line_callback():
    usb.control_transfer(dev, 0x40, LINE, 0, 0, 0, buffer)

def checkerboard_callback():
    usb.control_transfer(dev, 0x40, CHECKERBOARD, 0, 0, 0, buffer)

def halfhalf_callback():
    usb.control_transfer(dev, 0x40, HALF_HALF, 0, 0, 0, buffer)

def set_duty_callback(value):
    usb.control_transfer(dev, 0x40, SET_DUTY, int(value), 0, 0, buffer)

def update_status():
    root.after(50, update_status)

root = Tk()
root.title('ProjectButtons')
fm = Frame(root)
Button(fm, text = 'DOT', command = dot_callback).pack(side = LEFT)
Button(fm, text = 'LINE', command = line_callback).pack(side = LEFT)
Button(fm, text = 'CHECKERBOARD', command = checkerboard_callback).pack(side = LEFT)
Button(fm, text = 'HALF AND HALF', command = halfhalf_callback).pack(side = LEFT)##Button(fm, text = 'CLEAR', command = clr_valves_callback).pack(side = LEFT)
fm.pack(side = TOP)
dutyslider = Scale(root, from_ = 0, to = 255, orient = HORIZONTAL, showvalue = FALSE, command = set_duty_callback)
dutyslider.set(128)
dutyslider.pack(side = TOP)

dev = usb.open_device(0x6666, 0x0003, 0)
if dev<0:
    print "No matching device found...\n"
else:
    ret = usb.control_transfer(dev, 0x00, 0x09, 1, 0, 0, buffer)
    if ret<0:
        print "Unable to send SET_CONFIGURATION standard request.\n"
    root.after(50, update_status)
    root.mainloop()
    usb.close_device(dev)
